//+------------------------------------------------------------------+
//|                                              5min_Indicator6.mq4 |
//|                                     Ferrari Green Associates LTD |
//|                                    https://www.Ferrari-Green.com |
//+------------------------------------------------------------------+
#property copyright "Ferrari Green Associates LTD"
#property link      "https://www.Ferrari-Green.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

#property indicator_buffers 7


//---Indicator Colours
#property indicator_color1 clrGreen//up arrow
#property indicator_color2 clrRed//down arrow
#property indicator_color3 clrCrimson//SMA14
#property indicator_color7 clrNavy//HeikenAshi_tenkansen

//---Indicator Width
#property indicator_width1 2
#property indicator_width2 2

#include <WinUser32.mqh>
extern bool show=true;//Show Indicators?

double UpArrow[];
double DownArrow[];
double SMA14[];
double OSMA[];
double Momentum[];
double RSI[];
double HeikenAshi_tenkansen[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

//--- indicator buffers mapping
   SetIndexBuffer(0,UpArrow);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexLabel(0,"Buy Signal.");
//---
   SetIndexBuffer(1,DownArrow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexLabel(1,"Sell Signal.");
//---
   SetIndexBuffer(2,SMA14);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"SMA14.");
//---
   SetIndexBuffer(3,OSMA);
   SetIndexStyle(3,DRAW_LINE);
//---
   SetIndexBuffer(4,Momentum);
   SetIndexStyle(4,DRAW_LINE);
//---
   SetIndexBuffer(5,RSI);
   SetIndexStyle(5,DRAW_LINE);
//---
   SetIndexBuffer(6,HeikenAshi_tenkansen);
   SetIndexStyle(6,DRAW_HISTOGRAM);
//   SetIndexArrow(6,221);

//---   


   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---for loop
   int counted_bars=IndicatorCounted();
   int limit= Bars-counted_bars;
   for(int i=1;i<limit;i++)
     {
      double SMA=iMA(NULL,0,14,0,MODE_SMA,PRICE_MEDIAN,i);
      double Osma=iOsMA(NULL,0,12,26,9,PRICE_MEDIAN,i);
      double Mom=iMomentum(NULL,0,10,PRICE_MEDIAN,i);
      double Rsi=iRSI(NULL,0,5,PRICE_MEDIAN,i);
      double Heike_Tenkensan=iIchimoku(NULL,0,9,26,52,MODE_TENKANSEN,i);
      //---
      double Price=(High[i]+Low[i])/2;
      double PriceBack=(High[i+1]+Low[i+1])/2;
      if(show==true)
        {
         SMA14[i]=SMA;
         OSMA[i]=Osma;
         Momentum[i]=Mom;
         RSI[i]=Rsi;
         HeikenAshi_tenkansen[i]=Heike_Tenkensan;
        }
         if(Heike_Tenkensan>SMA)
            if(Osma>0)
               if(Mom>100)
                  if(Rsi>50)
                     if(Price>PriceBack)
                       {
                        UpArrow[i]=Open[i];
                       }
      if(Heike_Tenkensan<SMA)
         if(Osma<0)
            if(Mom<100)
               if(Rsi<50)
                  if(Price>PriceBack)
                    {
                     DownArrow[i]=Open[i];
                    }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
